local mod = RW:Boss("Festergut", "Icecrown Citadel", "Icecrown Citadel", "The Plagueworks")
local L

mod.BossIcon = [[Interface\Icons\achievement_boss_festergutrotface]]
mod.SubCatIcon = [[Interface\Icons\achievement_dungeon_plaguewing]]

---------------------------
-- Variables
--Spores
local iSpore, tSporeExplode, tSporeCD, wSpore, mSpore
--Inhale
local tInhaleCD, wInhale, mInhaleSoon
--Inhaled
local mInhaledStacks
--Pungent
local tPungentCD, tPungentcast, mPungentSoon, wPungentCast
--Gastric Bloat
local tGastricDur, tGastricCD, mGastric

---------------------------
-- Init	
function mod:OnRegister()
	L = mod:RegisterLocale(self:GetName(), "enUS", true)
	if L then
		L.name = "Festergut"
		L.info = "Untested mod, warnings and timers may be wrong"
		
		L.YellPull = "Fun time!"
		L.Yellkill = "NOOOO! You kill Sticky! You Pay!"
	end
	L = mod:GetLocale()
	mod.L = L
	
	mod:SetTrigger(L.YellPull, 36626)
	mod:SetWin(36626, L.Yellkill)
	
	
	tSporeCD		= self:CDTimer(35, 69278)
	tSporeExplode	= self:DurTimer(12, 69278)
	tInhaleCD		= self:CDTimer(30, 69165)
	tPungentCD		= self:CDTimer(30, 73032)
	tPungentcast	= self:CastTimer(3, 73032)
	tGastricCD		= self:CDTimer(11, 72219, nil, nil, false)
	tGastricDur		= self:DurTargetStackTimer(100, 72219, nil, nil, false)
	
	wSpore			= self:RunawayWarning(69278)
	wInhale			= self:CastWarning(69165)
	wPungentCast	= self:CastWarning(73032)
	
	mSpore			= self:TargetMessage(69278)
	mInhaleSoon		= self:SoonMessage(69165)
	mInhaledStacks	= self:StackMessage(71912)
	mPungentSoon	= self:SoonMessage(73032)
	mGastric		= self:TargetStackMessage(72219, nil, nil, false)
	
	iSpore			= self:Icon("STAR", 69278, false, 12, "CIRCLE", "DIAMOND", "TRIANGLE")
end
---------------------------
-- Locals

---------------------------
-- Start
function mod:OnEngage(trigger)
	self:Track("Spores", 69278, 69279, 71221, 69290, 71222, 73033, 73034) -- the later 4 are the debuff that the target take damage from, check loogs wich to keep
	self:Track("Inhale", 69165)
	self:Track("Inhaled", 71912, 69166)
	self:Track("Pungent", 73032, 69195, 71219, 73031)
	self:Track("Gastric", 72219, 72214, 72551, 72552, 72553, 72231)

	tSporeCD:Start(15)
	tInhaleCD:Start(30)
	mInhaleSoon:Schedule(25, "5s")

	self:Msg(L.info)
end

function mod:Spores(event, args)
	if event == "SPELL_AURA_APPLIED" then
		if args:IsPlayer() then
			wSpore:Show()
		end
		tSporeCD:Start()
		tSporeExplode:Start()
		mSpore:AddDelayTarget(args.dName)
		mSpore:DelayedShow(0.2)
		iSpore:Show(args.dName)
	end
end

function mod:Inhale(event, args)
	if event == "SPELL_CAST_START" then
		tInhaleCD:Schedule(3.5)
		wInhale:Show()
		mInhaleSoon:Schedule(27.5, "5s")
	end
end

function mod:Inhaled(event, args)
	if event == "SPELL_AURA_APPLIED" or event == "SPELL_AURA_APPLIED_DOSE" then
		mInhaledStacks:Show(args.amount or 1)
		
		if (args.amount or 1) >= 3 then
			mInhaleSoon:Cancel()
			tInhaleCD:Stop()
			
			tPungentCD:Start()
			mPungentSoon:Schedule(25, "5s")
		end
	end
end

function mod:Pungent(event, args)
	if event == "SPELL_CAST_START" then
		tPungentcast:Start()
		wPungentCast:Show()
		tPungentCD:Stop()
		mPungentSoon:Cancel()
		
		tInhaleCD:Schedule(3)
		mInhaleSoon:Schedule(27, "5s")
	end
end

function mod:Gastric(event, args)
	if event == "SPELL_AURA_APPLIED" or event == "SPELL_AURA_APPLIED_DOSE" then
		tGastricCD:Start()
		tGastricDur:Schedule(13, 87, args.dName, args.amount or 1)
		mGastric:Show(args.dName, args.amount or 1)
	end
end