local mod = RW:Boss("Professor Putricide", "Icecrown Citadel", "Icecrown Citadel", "The Plagueworks")
local L

mod.BossIcon = [[Interface\Icons\achievement_boss_profputricide]]

---------------------------
-- Variables
--Bloat
local iBloat, mBloat, wBloat
--Volatile Ooze Adhesive 
local iVolatiel, mVolatile, wVolatile, tVolativeCD
--Puddle
local wPuddle, mPuddle
-- Unstable Experiment 
local wExperiment, tExperimentCast
-- Create Concoction
local wConcoction, tConcoction
-- Guzzle Potions
local wGuzzle, tGuzzleCast
-- Choking Gas 
local wGas, mGas
-- Choking Gas Bomb
local wGasBomb, tGasBombExplode

---------------------------
-- Init	
function mod:OnRegister()
	L = mod:RegisterLocale(self:GetName(), "enUS", true)
	if L then
		L.name = "Professor Putricide"
		
		L.YellPull = "Good news, everyone! I think I perfected a plague that will destroy all life on Azeroth!"
		L.YellKill = "Bad news, everyone! I don't think I'm going to make it."
	end
	L = mod:GetLocale()
	mod.L = L
	
	mod:SetTrigger(36678, L.YellPull)
	mod:SetWin(36678, L.YellKill)
	
	tVolativeCD		= self:CDTimer(35, 72838)
	tExperimentCast = self:CastTimer(71968)
	tConcoction		= self:CastTimer(71621)
	tGuzzleCast		= self:CastTimer(71893)
	tGasBombExplode = self:DurTimer(20, 71255)
	
	wBloat			= self:RunawayWarning(70215)
	wVolatile		= self:Warning(72838)
	wPuddle			= self:RunawayWarning(72868)
	wExperiment		= self:CastWarning(71968)
	wConcoction		= self:CastWarning(71621)
	wGuzzle			= self:CastWarning(71893)
	wGasBomb		= self:CastWarning(71255)
	wGas			= self:InformWarning(72460)
	
	mBloat			= self:TargetMessage(70215)
	mVolatile		= self:TargetMessage(72838)
	mPuddle			= self:Message(72868)
	mGas			= self:TargetMessage(72460)
	
	iBloat			= self:Icon("SKULL", 70215, false)
	iVolatiel		= self:Icon("CROSS", 72838, false)
end

---------------------------
-- Locals

---------------------------
-- Start
function mod:OnEngage(trigger)
	self:Track("Bloat", 70215, 72860, 72859, 72858, 72832, 72833, 72455, 70672)
	self:Track("Volatile", 72838, 70447, 72836, 72837)
	self:Track("Puddle", 72868, 70346, 72869, 70341)
	self:Track("Experiment", 71968, 70351, 71966, 71967)
	self:Track("Concoction", 71621, 72851, 72850, 72852)
	self:Track("Guzzle", 71893, 73121, 73120, 73122)
	self:Track("GasBomb", 71255)
	self:Track("Gas", 72460, 71278, 72620, 72619)
end

function mod:Bloat(event, args)
	if event == "SPELL_AURA_APPLIED" then
		if args:IsPlayer() then
			wBloat:Show()
		end
		mBloat:Show(args.dName)
		iBloat:Show(args.dName)
	end
end

function mod:Volatile(event, args)
	if event == "SPELL_AURA_APPLIED" then
		iVolatiel:Show(args.dName)
		mVolatile:Show(args.dName)
		tVolativeCD:Start()
		if not args:IsPlayer() then
			wVolatile:Show()
		end
	end
end

function mod:Puddle(event, args)
	if event == "SPELL_AURA_APPLIED" then
		if args:IsPlayer() then
			wPuddle:Show()
		end
	
	elseif event == "SPELL_CAST_SUCCESS" then
		mPuddle:Show()
	end
end

function mod:Experiment(event, args)
	if event == "SPELL_CAST_START" then
		tExperimentCast:Start()
		wExperiment:Show()
	end
end

function mod:Concoction(event, args)
	if event == "SPELL_CAST_START" then
		wConcoction:Show()
		if self:InstanceSize() == 10 then
			tConcoction:Start(15)
		else
			tConcoction:Start()
		end
	end
end

function mod:Guzzle(event, args)
	if event == "SPELL_CAST_START" then
		wGuzzle:Show()
		if self:InstanceSize() == 10 then
			tGuzzleCast:Start(15)
		else
			tGuzzleCast:Start()
		end
	end
end

function mod:GasBomb(event, args)
	if event == "SPELL_CAST_SUCCESS" or event == "SPELL_CAST_START" then
		tGasBombExplode:Start()
		wGasBomb:Show()
	end
end

function mod:Gas(event, args)
	if event == "SPELL_AURA_APPLIED" then
		if args:IsPlayer() then
			wGas:Show()
		end
		mGas:Show(args.dName)
	end
end