local mod = RW:Boss("Rotface", "Icecrown Citadel", "Icecrown Citadel", "The Plagueworks")
local L

mod.BossIcon = [[Interface\Icons\spell_nature_acid_01]]

------------------------------------
-- Variables

local wInfection
local wOozeExplode
local tInfectionDur, tFloodCD, tGasCD
local tOozeExplode
local mInfection
local iInfection, iGas

-----------------------------------
-- Init

function mod:OnRegister()
	L = mod:RegisterLocale(self:GetName(), "enUS", true)
	if L then
		L.name = "Rotface"
		
		L.slime1 = "Good news, everyone! I've fixed the poison slime pipes!"
		L.slime2 = "Great news, everyone! The slime is flowing again!"
	end
	L = mod:GetLocale()
	mod.L = L
	
	mod:SetTrigger(36627)
	mod:SetWin()
	
	tInfectionDur 	= self:DurTargetTimer(12, 73023)
	tFloodCD 		= self:CDTimer(20, 71588)
	tGasCD 			= self:CDTimer(25, 72273)
	tOozeExplode 	= self:CastTimer(69839)
	
	wInfection 		= self:RunawayWarning(73023)
	wOozeExplode 	= self:RunawayWarning(69839)
	
	mInfection 		= self:TargetMessage(73023)
	
	iInfection 		= self:Icon("SKULL", 73023)
	iGas 			= self:Icon("CROSS", 72273, nil, nil, "STAR", "CIRCLE", "DIAMOND")
end

-----------------------------------------
-- Start

function mod:OnEngage()
	self:Track("Infection", 73023, 73022, 71224, 69674)
	self:Track("Gas", 72273, 69240, 72273, 73019, 72274, 72272, 69248, 71218, 73020)
	self:Track("OozeExplode", 69839)
	
	self:YellTrack("Flood", L.slime1, L.slime2)
end

function mod:Infection(event, args)
	if event == "SPELL_AURA_APPLIED" then
		tInfectionDur:Start(args.dName)
		iInfection:Show(args.dName)
		mInfection:Show(args.dName)
		if args:IsPlayer() then
			wInfection:Show()
		end
	elseif event == "SPELL_AURA_REMOVED" then
		tInfectionDur:Stop()
		iInfection:Hide(args.dName)
	end
end

function mod:Gas(event, args)
	if event == "SPELL_AURA_APPLIED" then
		iGas:Show(args.dName)
	elseif event == "SPELL_AURA_REMOVED" then
		iGas:Hide(args.dName)
	elseif event == "SPELL_CAST_SUCCESS" then
		tGasCD:Start()
	end
end

function mod:OozeExplode(event, args)
	if event == "SPELL_CAST_START" then
		tOozeExplode:Start()
		wOozeExplode:Schedule(tOozeExplode.time)
	end
end

function mod:Flood(event, msg, name)
	tFloodCD:Start()
end